Index: /trunk/LMDZ.GENERIC/libf/phystd/physiq.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/physiq.F90	(revision 1216)
@@ -10,14 +10,20 @@
       use radinc_h, only : L_NSPECTI,L_NSPECTV,naerkind
       use watercommon_h, only : RLVTT, Psat_water,epsi
-      use gases_h
+      use gases_h, only: gnom, gfrac
       use radcommon_h, only: sigma, eclipse, glat, grav
       use radii_mod, only: h2o_reffrad, co2_reffrad, h2o_cloudrad
-      use aerosol_mod
-      use surfdat_h
-      use comdiurn_h
-      use comsaison_h
-      use comsoil_h
-      USE comgeomfi_h
-      USE tracer_h
+      use aerosol_mod, only: iaero_co2, iaero_h2o
+      use surfdat_h, only: phisfi, albedodat, zmea, zstd, zsig, zgam, zthe, &
+                           dryness, watercaptag
+      use comdiurn_h, only: coslat, sinlat, coslon, sinlon
+      use comsaison_h, only: mu0, fract, dist_star, declin
+      use comsoil_h, only: nsoilmx, layer, mlayer, inertiedat
+      USE comgeomfi_h, only: long, lati, area, totarea
+      USE tracer_h, only: noms, mmol, radius, rho_q, qext, &
+                          alpha_lift, alpha_devil, qextrhor, &
+                          igcm_h2o_ice, igcm_h2o_vap, igcm_dustbin, &
+                          igcm_co2_ice
+      use control_mod, only: ecritphy, iphysiq, nday
+      use phyredem, only: physdem0, physdem1
 
       implicit none
@@ -80,5 +86,5 @@
 !    pt(ngrid,nlayer)      Temperature (K)
 !    pq(ngrid,nlayer,nq)   Advected fields
-!    pudyn(ngrid,nlayer)    \ 
+!    pudyn(ngrid,nlayer)    \
 !    pvdyn(ngrid,nlayer)     \ Dynamical temporal derivative for the
 !    ptdyn(ngrid,nlayer)     / corresponding variables
@@ -123,5 +129,5 @@
 #include "comcstfi.h"
 #include "planete.h"
-#include "control.h"
+!#include "control.h"
 #include "netcdf.inc"
 
@@ -621,4 +627,10 @@
                             ! need epsi for the wvp definitions in callcorrk.F
 
+         if (ngrid.ne.1) then ! no need to create a restart file in 1d
+           call physdem0("restartfi.nc",long,lati,nsoilmx,ngrid,nlayer,nq, &
+                         ptimestep,pday+nday,time_phys,area, &
+                         albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe)
+         endif
+         
       endif        !  (end of "if firstcall")
 
@@ -626,5 +638,4 @@
 ! 1.2   Initializations done at every physical timestep:
 ! ---------------------------------------------------
-
 !     Initialize various variables
 !     ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -655,5 +666,5 @@
 !    Compute variations of g with latitude (oblate case)
 !
-        if (oblate .eq. .false.) then
+        if (oblate .eqv. .false.) then
            glat(:) = g
         else if (flatten .eq. 0.0 .or. J2 .eq. 0.0 .or. Rmean .eq. 0.0 .or. MassPlanet .eq. 0.0) then
@@ -734,5 +745,5 @@
                call stelang(ngrid,sinlon,coslon,sinlat,coslat,    &
                ztim1,ztim2,ztim3,mu0,fract, flatten)
-           else if(diurnal .eq. .false.) then
+           else if(diurnal .eqv. .false.) then
 
                call mucorr(ngrid,declin,lati,mu0,fract,10000.,rad,flatten)
@@ -745,5 +756,5 @@
            if(rings_shadow) then 
                 write(*,*) 'Rings shadow activated'
-                if(diurnal .eq. .false.) then ! we need to compute the daily average insolation 
+                if(diurnal .eqv. .false.) then ! we need to compute the daily average insolation 
                     pas = 1./nb_hours
                     ptime_day = 0.
@@ -784,5 +795,4 @@
             endif
 
-
            if (corrk) then
 
@@ -1531,5 +1541,5 @@
 
          if(meanOLR)then
-            if((ngrid.gt.1) .or. (mod(icount-1,nint(ecritphy)).eq.0))then
+            if((ngrid.gt.1) .or. (mod(icount-1,ecritphy).eq.0))then
                ! to record global radiative balance
                open(92,file="rad_bal.out",form='formatted',position='append')
@@ -1607,5 +1617,5 @@
 
          if(meanOLR)then
-            if((ngrid.gt.1) .or. (mod(icount-1,nint(ecritphy)).eq.0))then
+            if((ngrid.gt.1) .or. (mod(icount-1,ecritphy).eq.0))then
                ! to record global water balance
                open(98,file="h2o_bal.out",form='formatted',position='append')
@@ -1681,17 +1691,24 @@
             endif
 
-            write(*,*)'PHYSIQ: for physdem ztime_fin =',ztime_fin
-#ifdef CPP_PARA
-! for now in parallel we use a different routine to write restartfi.nc
-            call phyredem(ngrid,"restartfi.nc",           &
-                    ptimestep,pday,ztime_fin,tsurf,tsoil,emis,q2,qsurf_hist, &
-                    cloudfrac,totcloudfrac,hice)
-#else
-            call physdem1(ngrid,"restartfi.nc",long,lati,nsoilmx,nq,            &
-                    ptimestep,pday,ztime_fin,tsurf,tsoil,emis,q2,qsurf_hist, &
-                    area,albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe,      &
-                    cloudfrac,totcloudfrac,hice,noms)
-#endif
-         endif
+            if (ngrid.ne.1) then
+              write(*,*)'PHYSIQ: for physdem ztime_fin =',ztime_fin
+!#ifdef CPP_PARA
+!! for now in parallel we use a different routine to write restartfi.nc
+!            call phyredem(ngrid,"restartfi.nc",           &
+!                    ptimestep,pday,ztime_fin,tsurf,tsoil,emis,q2,qsurf_hist, &
+!                    cloudfrac,totcloudfrac,hice)
+!#else
+!            call physdem1(ngrid,"restartfi.nc",long,lati,nsoilmx,nq,            &
+!                    ptimestep,pday,ztime_fin,tsurf,tsoil,emis,q2,qsurf_hist, &
+!                    area,albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe,      &
+!                    cloudfrac,totcloudfrac,hice,noms)
+!#endif
+              call physdem1("restartfi.nc",nsoilmx,ngrid,nlayer,nq, &
+                      ptimestep,ztime_fin, &
+                      tsurf,tsoil,emis,q2,qsurf_hist, &
+                      cloudfrac,totcloudfrac,hice)
+            endif
+         
+         endif ! of if (lastcall)
 
 
Index: /trunk/LMDZ.GENERIC/libf/phystd/planetwide_mod.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/planetwide_mod.F90	(revision 1216)
+++ /trunk/LMDZ.GENERIC/libf/phystd/planetwide_mod.F90	(revision 1216)
@@ -0,0 +1,203 @@
+!
+! $Id: $
+!
+module planetwide_mod
+! module which contains functions to obtain max/min/... values over the
+! entire globe (trivial in serial mode, but not in parallel)
+
+use mod_phys_lmdz_para, only : is_master, gather, bcast
+                               
+implicit none
+
+interface planetwide_maxval ! maxval() , over the entire planet
+  module procedure planetwide_maxval_i1, planetwide_maxval_i2, &
+                   planetwide_maxval_r1, planetwide_maxval_r2
+end interface
+
+interface planetwide_minval ! minval() , over the entire planet
+  module procedure planetwide_minval_i1, planetwide_minval_i2, &
+                   planetwide_minval_r1, planetwide_minval_r2
+end interface
+
+contains
+
+  subroutine planetwide_maxval_i1(values,values_max)
+  use dimphy, only: klon
+  use mod_grid_phy_lmdz, only : klon_glo
+  implicit none
+  integer,intent(in) :: values(:) ! local grid (klon)
+  integer,intent(out) :: values_max
+#ifdef CPP_PARA
+  integer :: values_glo(klon_glo) ! global grid
+  
+  ! gather field on master:
+  call gather(values,values_glo)
+  ! extract maximum value
+  if (is_master) then
+    values_max=maxval(values_glo)
+  endif
+  ! broadcast information to all cores
+  call bcast(values_max)
+#else
+  values_max=maxval(values)
+#endif
+  end subroutine planetwide_maxval_i1
+
+  subroutine planetwide_maxval_i2(values,values_max)
+  use dimphy, only: klon, klev
+  use mod_grid_phy_lmdz, only : klon_glo
+  implicit none
+  integer,intent(in) :: values(:,:) ! local grid (klon,klev)
+  integer,intent(out) :: values_max
+#ifdef CPP_PARA
+  integer :: values_glo(klon_glo,klev) ! global grid
+  
+  ! gather field on master:
+  call gather(values,values_glo)
+  ! extract maximum value
+  if (is_master) then
+    values_max=maxval(values_glo)
+  endif
+  ! broadcast information to all cores
+  call bcast(values_max)
+#else
+  values_max=maxval(values)
+#endif
+  end subroutine planetwide_maxval_i2
+
+  subroutine planetwide_maxval_r1(values,values_max)
+  use dimphy, only: klon
+  use mod_grid_phy_lmdz, only : klon_glo
+  implicit none
+  real,intent(in) :: values(:) ! local grid (klon)
+  real,intent(out) :: values_max
+#ifdef CPP_PARA
+  real :: values_glo(klon_glo) ! global grid
+  
+  ! gather field on master:
+  call gather(values,values_glo)
+  ! extract maximum value
+  if (is_master) then
+    values_max=maxval(values_glo)
+  endif
+  ! broadcast information to all cores
+  call bcast(values_max)
+#else
+  values_max=maxval(values)
+#endif
+  end subroutine planetwide_maxval_r1
+
+  subroutine planetwide_maxval_r2(values,values_max)
+  use dimphy, only: klon, klev
+  use mod_grid_phy_lmdz, only : klon_glo
+  implicit none
+  real,intent(in) :: values(:,:) ! local grid (klon,klev)
+  real,intent(out) :: values_max
+#ifdef CPP_PARA
+  real :: values_glo(klon_glo,klev) ! global grid
+  
+  ! gather field on master:
+  call gather(values,values_glo)
+  ! extract maximum value
+  if (is_master) then
+    values_max=maxval(values_glo)
+  endif
+  ! broadcast information to all cores
+  call bcast(values_max)
+#else
+  values_max=maxval(values)
+#endif
+  end subroutine planetwide_maxval_r2
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+  subroutine planetwide_minval_i1(values,values_max)
+  use dimphy, only: klon
+  use mod_grid_phy_lmdz, only : klon_glo
+  implicit none
+  integer,intent(in) :: values(:) ! local grid (klon)
+  integer,intent(out) :: values_max
+#ifdef CPP_PARA
+  integer :: values_glo(klon_glo) ! global grid
+  
+  ! gather field on master:
+  call gather(values,values_glo)
+  ! extract maximum value
+  if (is_master) then
+    values_max=minval(values_glo)
+  endif
+  ! broadcast information to all cores
+  call bcast(values_max)
+#else
+  values_max=minval(values)
+#endif
+  end subroutine planetwide_minval_i1
+
+  subroutine planetwide_minval_i2(values,values_max)
+  use dimphy, only: klon, klev
+  use mod_grid_phy_lmdz, only : klon_glo
+  implicit none
+  integer,intent(in) :: values(:,:) ! local grid (klon,klev)
+  integer,intent(out) :: values_max
+#ifdef CPP_PARA
+  integer :: values_glo(klon_glo,klev) ! global grid
+  
+  ! gather field on master:
+  call gather(values,values_glo)
+  ! extract maximum value
+  if (is_master) then
+    values_max=minval(values_glo)
+  endif
+  ! broadcast information to all cores
+  call bcast(values_max)
+#else
+  values_max=minval(values)
+#endif
+  end subroutine planetwide_minval_i2
+
+  subroutine planetwide_minval_r1(values,values_max)
+  use dimphy, only: klon
+  use mod_grid_phy_lmdz, only : klon_glo
+  implicit none
+  real,intent(in) :: values(:) ! local grid (klon)
+  real,intent(out) :: values_max
+#ifdef CPP_PARA
+  real :: values_glo(klon_glo) ! global grid
+  
+  ! gather field on master:
+  call gather(values,values_glo)
+  ! extract maximum value
+  if (is_master) then
+    values_max=minval(values_glo)
+  endif
+  ! broadcast information to all cores
+  call bcast(values_max)
+#else
+  values_max=minval(values)
+#endif
+  end subroutine planetwide_minval_r1
+
+  subroutine planetwide_minval_r2(values,values_max)
+  use dimphy, only: klon, klev
+  use mod_grid_phy_lmdz, only : klon_glo
+  implicit none
+  real,intent(in) :: values(:,:) ! local grid (klon,klev)
+  real,intent(out) :: values_max
+#ifdef CPP_PARA
+  real :: values_glo(klon_glo,klev) ! global grid
+  
+  ! gather field on master:
+  call gather(values,values_glo)
+  ! extract maximum value
+  if (is_master) then
+    values_max=minval(values_glo)
+  endif
+  ! broadcast information to all cores
+  call bcast(values_max)
+#else
+  values_max=minval(values)
+#endif
+  end subroutine planetwide_minval_r2
+
+
+end module planetwide_mod
Index: /trunk/LMDZ.GENERIC/libf/phystd/rcm1d.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/rcm1d.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/rcm1d.F	(revision 1216)
@@ -2,11 +2,17 @@
 
 ! to use  'getin'
-      use ioipsl_getincom 
-      use surfdat_h
-      use comdiurn_h
-      use comsaison_h
-      use comsoil_h
-      USE comgeomfi_h
-
+      use ioipsl_getincom, only: getin
+      use infotrac, only: nqtot, tname
+      use surfdat_h, only: albedodat, phisfi, dryness, watercaptag,
+     &                     zmea, zstd, zsig, zgam, zthe,
+     &                     emissiv, emisice, albedice, iceradius,
+     &                     dtemisice
+      use comdiurn_h, only: sinlat, coslat, sinlon, coslon
+!      use comsaison_h
+      use comsoil_h, only: nsoilmx, layer, mlayer, inertiedat, volcapa
+      USE comgeomfi_h, only: lati, long, area
+      use control_mod, only: day_step, ecritphy
+      use phyredem, only: physdem0,physdem1
+      use comgeomphy, only: initcomgeomphy
       implicit none
 
@@ -41,5 +47,5 @@
 #include "comcstfi.h"
 #include "planete.h"
-#include "control.h"
+!#include "control.h"
 #include "comvert.h"
 #include "netcdf.inc"
@@ -61,10 +67,10 @@
       REAL play(nlayermx)   ! Pressure at the middle of the layers (Pa)
       REAL plev(nlayermx+1) ! intermediate pressure levels (pa)
-      REAL psurf,tsurf      
+      REAL psurf,tsurf(1)      
       REAL u(nlayermx),v(nlayermx)  ! zonal, meridional wind
       REAL gru,grv   ! prescribed "geostrophic" background wind
       REAL temp(nlayermx)   ! temperature at the middle of the layers
-      REAL q(nlayermx,nqmx) ! tracer mixing ratio (e.g. kg/kg)
-      REAL qsurf(nqmx)      ! tracer surface budget (e.g. kg.m-2)
+      REAL,ALLOCATABLE :: q(:,:) ! tracer mixing ratio (e.g. kg/kg)
+      REAL,ALLOCATABLE :: qsurf(:)      ! tracer surface budget (e.g. kg.m-2)
       REAL tsoil(nsoilmx)   ! subsurface soik temperature (K)
 !      REAL co2ice           ! co2ice layer (kg.m-2) !not used anymore
@@ -72,5 +78,5 @@
       integer :: i_h2o_ice=0  ! tracer index of h2o ice
       integer :: i_h2o_vap=0  ! tracer index of h2o vapor
-      REAL emis             ! surface layer
+      REAL emis(1)             ! surface layer
       REAL q2(nlayermx+1)   ! Turbulent Kinetic Energy
       REAL zlay(nlayermx)   ! altitude estimee dans les couches (km)
@@ -80,6 +86,6 @@
       REAL dudyn(nlayermx),dvdyn(nlayermx),dtempdyn(nlayermx)
       REAL dpsurf    
-      REAL dq(nlayermx,nqmx)
-      REAL dqdyn(nlayermx,nqmx)
+      REAL,ALLOCATABLE :: dq(:,:)
+      REAL,ALLOCATABLE :: dqdyn(:,:)
 
 c   Various intermediate variables
@@ -88,5 +94,4 @@
       REAL phi(nlayermx),h(nlayermx),s(nlayermx)
       REAL pks, ptif, w(nlayermx)
-      REAL qtotinit, mqtot(nqmx),qtot
       INTEGER ierr, aslun
       REAL tmp1(0:nlayermx),tmp2(0:nlayermx)
@@ -112,10 +117,14 @@
 
 !     added by AS to avoid the use of adv trac common
-      character*20 nametrac(nqmx)   ! name of the tracer (no need for adv trac common)
-
+      character*20,allocatable :: nametrac(:)   ! name of the tracer (no need for adv trac common)
+
+      real :: latitude, longitude
 
 c=======================================================================
 c INITIALISATION
 c=======================================================================
+! initialize "serial/parallel" related stuff
+      CALL init_phys_lmdz(iim,jjm+1,llm,1,(/(jjm-1)*iim+2/))
+      call initcomgeomphy
 
       !! those are defined in surfdat_h.F90
@@ -227,20 +236,23 @@
           ! read number of tracers:
           read(90,*,iostat=ierr) nq
+          nqtot=nq ! set value of nqtot (in infotrac module) as nq
           if (ierr.ne.0) then
             write(*,*) "rcm1d: error reading number of tracers"
             write(*,*) "   (first line of traceur.def) "
             stop
+          endif
+          if (nq>0) then
+            allocate(tname(nq))
+            allocate(q(nlayermx,nq))
+            allocate(qsurf(nq))
+            allocate(dq(nlayermx,nq))
+            allocate(dqdyn(nlayermx,nq))
           else
-            ! check that the number of tracers is indeed nqmx
-            if (nq.ne.nqmx) then
-              write(*,*) "rcm1d: error, wrong number of tracers:"
-              write(*,*) "nq=",nq," whereas nqmx=",nqmx
-              stop
-            endif
+            allocate(tname(1)) ! tname(1) is used below, even if nq=0
           endif
         
           do iq=1,nq
           ! minimal version, just read in the tracer names, 1 per line
-            read(90,*,iostat=ierr) nametrac(iq)
+            read(90,*,iostat=ierr) tname(iq)
             if (ierr.ne.0) then
               write(*,*) 'rcm1d: error reading tracer names...'
@@ -253,9 +265,9 @@
          i_h2o_vap=0
          do iq=1,nq
-           if (nametrac(iq)=="co2_ice") then
+           if (tname(iq)=="co2_ice") then
              i_co2_ice=iq
-           elseif (nametrac(iq)=="h2o_ice") then
+           elseif (tname(iq)=="h2o_ice") then
              i_h2o_ice=iq
-           elseif (nametrac(iq)=="h2o_vap") then
+           elseif (tname(iq)=="h2o_vap") then
              i_h2o_vap=iq
            endif
@@ -275,5 +287,14 @@
 
       else
-       nq=nqmx
+       nq=nqtot
+       if (nq>0) then
+            allocate(tname(nq))
+            allocate(q(nlayermx,nq))
+            allocate(qsurf(nq))
+            allocate(dq(nlayermx,nq))
+            allocate(dqdyn(nlayermx,nq))
+        else
+            allocate(tname(1)) ! tname(1) is used below, even if nq=0
+        endif
        ! Check that tracer boolean is compliant with number of tracers
        ! -- otherwise there is an error (and more generally we have to be consistent)
@@ -290,10 +311,10 @@
         do iq=1,nq
           write(str7,'(a1,i2.2)')'q',iq
-          nametrac(iq)=str7
+          tname(iq)=str7
         enddo
         ! actually, we'll need at least one "co2_ice" tracer
         ! (for surface CO2 ice)
-        nametrac(1)="co2_ice"
         i_co2_ice=1
+        tname(i_co2_ice)="co2_ice"
       endif ! of if (tracer)
 
@@ -315,12 +336,12 @@
       phisfi(1)=0.E+0
      !!! LATITUDE. can be set. 
-      lati(1)=0 ! default value for lati(1)
+      latitude=0 ! default value for latitude
       PRINT *,'latitude (in degrees) ?'
-      call getin("latitude",lati(1))
-      write(*,*) " latitude = ",lati(1)
-      lati(1)=lati(1)*pi/180.E+0
+      call getin("latitude",latitude)
+      write(*,*) " latitude = ",latitude
+      latitude=latitude*pi/180.E+0
      !!! LONGITUDE. useless in 1D.
-      long(1)=0.E+0
-      long(1)=long(1)*pi/180.E+0
+      longitude=0.E+0
+      longitude=longitude*pi/180.E+0
 
 !!! CALL INIFIS
@@ -332,6 +353,6 @@
 !!! - physical frequency: nevermind, in inifis this is a simple print
       cpp=1.d-7 !JL because we divide by cpp in inifis, there may be a more elegant solution
-      CALL inifis(1,llm,day0,daysec,dtphys,
-     .            lati,long,area,rad,g,r,cpp)
+      CALL inifis(1,llm,nq,day0,daysec,dtphys,
+     .            latitude,longitude,area,rad,g,r,cpp)
 !!! We check everything is OK.
       PRINT *,"CHECK"
@@ -558,9 +579,9 @@
 c  emissivity / surface co2 ice ( + h2o ice??)
 c  -------------------------------------------
-      emis=emissiv ! default value for emissivity
+      emis(1)=emissiv ! default value for emissivity
       PRINT *,'Emissivity of bare ground ?'
-      call getin("emis",emis)
-      write(*,*) " emis = ",emis
-      emissiv=emis ! we do this so that condense_co2 sets things to the right
+      call getin("emis",emis(1))
+      write(*,*) " emis = ",emis(1)
+      emissiv=emis(1) ! we do this so that condense_co2 sets things to the right
                    ! value if there is no snow
 
@@ -573,7 +594,7 @@
             ! if we have some CO2 ice on the surface, change emissivity
             if (lati(1).ge.0) then ! northern hemisphere
-              emis=emisice(1)
+              emis(1)=emisice(1)
             else ! southern hemisphere
-              emis=emisice(2)
+              emis(1)=emisice(2)
             endif
          ENDIF
@@ -673,10 +694,10 @@
       call profile(nlayer+1,tmp1,tmp2)
 
-      tsurf=tmp2(0)
+      tsurf(1)=tmp2(0)
       DO ilayer=1,nlayer
         temp(ilayer)=tmp2(ilayer)
       ENDDO
       print*,"check"
-      PRINT*,"INPUT SURFACE TEMPERATURE",tsurf
+      PRINT*,"INPUT SURFACE TEMPERATURE",tsurf(1)
       PRINT*,"INPUT TEMPERATURE PROFILE",temp
 
@@ -698,5 +719,5 @@
       DO isoil=1,nsoil
          inertiedat(1,isoil)=inertiedat(1,1) ! soil thermal inertia
-         tsoil(isoil)=tsurf  ! soil temperature
+         tsoil(isoil)=tsurf(1)  ! soil temperature
       ENDDO
 
@@ -711,15 +732,22 @@
 
 
-c  Ecriture de "startfi"
+c  Write a "startfi" file
 c  --------------------
-c  (Ce fichier sera aussitot relu au premier
-c   appel de "physiq", mais il est necessaire pour passer
-c   les variables purement physiques a "physiq"...
-
-      call physdem1(1,"startfi.nc",long,lati,nsoilmx,nq,
-     &              dtphys,float(day0),
-     &              time,tsurf,tsoil,emis,q2,qsurf,
-     &              area,albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe,
-     &              cloudfrac,totcloudfrac,hice,nametrac)
+c  This file will be read during the first call to "physiq".
+c  It is needed to transfert physics variables to "physiq"...
+
+      call physdem0("startfi.nc",long,lati,nsoilmx,1,llm,nq,
+     &              dtphys,real(day0),time,area,
+     &              albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe)
+      call physdem1("startfi.nc",nsoilmx,1,llm,nq,
+     &                dtphys,time,
+     &                tsurf,tsoil,emis,q2,qsurf,
+     &                cloudfrac,totcloudfrac,hice)
+
+!      call physdem1(1,"startfi.nc",long,lati,nsoilmx,nq,
+!     &              dtphys,float(day0),
+!     &              time,tsurf,tsoil,emis,q2,qsurf,
+!     &              area,albedodat,inertiedat,zmea,zstd,zsig,zgam,zthe,
+!     &              cloudfrac,totcloudfrac,hice,nametrac)
 
 c=======================================================================
@@ -775,5 +803,5 @@
 
       CALL physiq (1,llm,nq,
-     .     nametrac,
+     .     tname,
      ,     firstcall,lastcall,
      ,     day,time,dtphys,
@@ -858,4 +886,6 @@
       ENDDO   ! fin de la boucle temporelle
 
+      write(*,*) "rcm1d: Everything is cool."
+
 c    ========================================================
       end                       !rcm1d
@@ -874,2 +904,3 @@
 
 #include "../dyn3d/disvert.F"
+#include "../dyn3d/abort_gcm.F"
Index: /trunk/LMDZ.GENERIC/libf/phystd/soil.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/soil.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/soil.F	(revision 1216)
@@ -4,5 +4,5 @@
      &          capcal,fluxgrd)
 
-      use comsoil_h
+      use comsoil_h, only: layer, mlayer, volcapa
 
       implicit none
@@ -17,6 +17,6 @@
 !-----------------------------------------------------------------------
 
-#include "dimensions.h"
-#include "dimphys.h"
+      include "dimensions.h"
+      include "dimphys.h"
 
 
@@ -25,15 +25,15 @@
 !  ---------
 !  inputs:
-      integer ngrid	! number of (horizontal) grid-points 
-      integer nsoil	! number of soil layers 
-      logical firstcall ! identifier for initialization call 
-      logical lastcall
-      real therm_i(ngrid,nsoil) ! thermal inertia
-      real timestep	    ! time step
-      real tsurf(ngrid)   ! surface temperature
+      integer,intent(in) :: ngrid	! number of (horizontal) grid-points 
+      integer,intent(in) :: nsoil	! number of soil layers 
+      logical,intent(in) :: firstcall ! identifier for initialization call 
+      logical,intent(in) :: lastcall
+      real,intent(in) :: therm_i(ngrid,nsoil) ! thermal inertia
+      real,intent(in) :: timestep	    ! time step
+      real,intent(in) :: tsurf(ngrid)   ! surface temperature
 ! outputs:
-      real tsoil(ngrid,nsoil) ! soil (mid-layer) temperature
-      real capcal(ngrid) ! surface specific heat
-      real fluxgrd(ngrid) ! surface diffusive heat flux
+      real,intent(out) :: tsoil(ngrid,nsoil) ! soil (mid-layer) temperature
+      real,intent(out) :: capcal(ngrid) ! surface specific heat
+      real,intent(out) :: fluxgrd(ngrid) ! surface diffusive heat flux
 
 ! local saved variables:
@@ -50,7 +50,4 @@
 
 
-!      print*,'tsoil=',tsoil
-!      print*,'tsurf=',tsurf
-
 ! 0. Initialisations and preprocessing step
       if (firstcall) then
@@ -58,10 +55,10 @@
       !       and not changed by soil.F 
 
-      ALLOCATE(mthermdiff(ngrid,0:nsoilmx-1)) ! mid-layer thermal diffusivity
-      ALLOCATE(thermdiff(ngrid,nsoilmx-1))    ! inter-layer thermal diffusivity
-      ALLOCATE(coefq(0:nsoilmx-1))              ! q_{k+1/2} coefficients
-      ALLOCATE(coefd(ngrid,nsoilmx-1))        ! d_k coefficients
-      ALLOCATE(alph(ngrid,nsoilmx-1))         ! alpha_k coefficients
-      ALLOCATE(beta(ngrid,nsoilmx-1))         ! beta_k coefficients
+      ALLOCATE(mthermdiff(ngrid,0:nsoil-1)) ! mid-layer thermal diffusivity
+      ALLOCATE(thermdiff(ngrid,nsoil-1))    ! inter-layer thermal diffusivity
+      ALLOCATE(coefq(0:nsoil-1))              ! q_{k+1/2} coefficients
+      ALLOCATE(coefd(ngrid,nsoil-1))        ! d_k coefficients
+      ALLOCATE(alph(ngrid,nsoil-1))         ! alpha_k coefficients
+      ALLOCATE(beta(ngrid,nsoil-1))         ! beta_k coefficients
 
 ! 0.1 Build mthermdiff(:), the mid-layer thermal diffusivities
@@ -187,13 +184,4 @@
       enddo
 
-      if (lastcall) then
-        IF ( ALLOCATED(mthermdiff)) DEALLOCATE(mthermdiff)
-        IF ( ALLOCATED(thermdiff)) DEALLOCATE(thermdiff)
-        IF ( ALLOCATED(coefq)) DEALLOCATE(coefq)
-        IF ( ALLOCATED(coefd)) DEALLOCATE(coefd)
-        IF ( ALLOCATED(alph)) DEALLOCATE(alph)
-        IF ( ALLOCATED(beta)) DEALLOCATE(beta)
-      endif
-
       end
 
